Subject: Re: bug#51343: 27.2; Xaw3d scrollbar thumb doesn't update while dragged

From: Po Lu <[email-masked]>
Date: Mon, 20 Dec 2021 09:07:20 +0800

Stefan Monnier <[email-masked]> writes:

> Po Lu [2021-10-23 15:32:48] wrote:
>> Previously, in an Emacs built with Xaw3d scroll bars, the thumb
>> proportion would update as the scrollbar was dragged.  Now it doesn't
>> update until the scrollbar is released, and something that makes the
>> scrollbar position change happens.
>
> To give you some context:
>
> Many years ago, I spent a fair bit of time trying to get scrollbars
> working "right".  It's a major pain in the ass, because most toolkits
> don't support our requirements: once the bottom of the thumb hits the
> bottom of its course it stops there, but the corresponding top part of
> the thumb may correspond to a window-start which leads to a screen where
> point-max is not visible (in response to which we'd reduce the size of
> the thumb, but that happens too late (either because the toolkit has
> already decided not to tell us that the user's mouse was trying to go
> further, or because the toolkit doesn't support updating the thumb size
> while dragging it).
>
> There was a simple patch to Xaw3d which made it behave more like Xaw (by
> making the Xaw3d more like Xaw's) and made the whole thing work
> perfectly for us, but it was never accepted upstream because it went
> against their philosophy of what "the metaphor should be".

This particular feature used to work in Emacs 23 though, so that can't
be the entirety of the problem.